
document.tm_js_loaded;
const windowWidth = window.innerWidth;


//INIT
document.addEventListener('DOMContentLoaded', function () {

    const totalmenuWrappers = document.querySelectorAll('.totalmenu_wrapper');

    for (const totalmenuWrapper of totalmenuWrappers) {
        const id = totalmenuWrapper.getAttribute('id');

        // TODO: Implement the `tm_init_v2()` function.
        tm_init_v3(id);

        if (typeof document.tm_js_loaded === 'undefined') tm_init_once();

    }
});


///////////////////////////
/////INIT ONCE/////////
///////////////////////////
function tm_init_once() {
    document.tm_js_loaded = true;

    outerClick_v5();
  
    const totalMenus = document.querySelectorAll('.totalmenu_wrapper');
  
    
    //init values
    for (const tm of totalMenus) {
     
        const media_w = _tm['tm_'+tm.id].mediaw;

        if (windowWidth < media_w) {                  
            _tm['tm_'+tm.id].currentMedia = 'mobile';
            _tm['tm_'+tm.id].portal = false;
        }else{
            _tm['tm_'+tm.id].currentMedia = 'desktop';
            _tm['tm_'+tm.id].portal = false;
        }

        const tmParams = _tm['tm_'+tm.id];

        tmPortal(tm, tmParams);
        StartOpened(tmParams);
        tmCustomColor(tm, tmParams);
    }

}

///////////////////////////
/////INIT CLOSE ELEMENTS/////////
///////////////////////////
function initMenus(tm) {
    const liElements = tm.querySelectorAll("li.tm_open");

    for (const liElement of liElements) {
        liElement.classList.remove("tm_open");
        liElement.classList.add("tm_close");
    }
}

///////////////////////////
/////onClick*OPENCLOSE/////////
///////////////////////////
function tm_init_v3(id) {

    //init params
    const windowW = window.innerWidth;
    const tmParams = _tm['tm_'+id];
    if(windowW < tmParams.mediaw){
        _tm['tm_'+id].currentMedia = 'mobile';
    }else{
        _tm['tm_'+id].currentMedia = 'desktop';
    }

    const uniqueElement = document.querySelector('#' + id);
    const childrenUl = uniqueElement.querySelectorAll('ul');

    //remove styles
    for (const childElement of childrenUl) {
        childElement.style = '';
        childElement.classList.remove('tm_loading');
        childElement.classList.add('tm_loaded');
    }

    uniqueElement.classList.remove('tm_loading');
    uniqueElement.classList.add('tm_loaded');

}


///////////////////////////
/////onClick*OPENCLOSE/////////
///////////////////////////
function tmOpenSubmenu(button) {
    const divGroup = button.parentNode;
    const liItem = divGroup.parentNode;
    const tmID = findParentUl(liItem).id;
    const totalmenu = document.getElementById(tmID);

    const tmParams = _tm['tm_'+tmID];

    const desk_dir = tmParams.desk_dir;
    const mobile_dir = tmParams.mobile_dir;
    const mediaw = tmParams.mediaw;

    const windowW = window.innerWidth;


    if (windowW < mediaw && mobile_dir == 'vertical') tmOpenVertical(button);
    if (windowW < mediaw && mobile_dir == 'horizontal') tmOpenHorizontal(button);

    if (windowW >= mediaw && desk_dir == 'vertical') tmOpenVertical(button);
    if (windowW >= mediaw && desk_dir == 'horizontal') tmOpenHorizontal(button);

}

///////////////////////////
/////onClick******VERTICAL/////////
///////////////////////////
function tmOpenVertical(button) {

    const divGroup = button.parentNode;
    const liItem = divGroup.parentNode;
    const ulItem = liItem.parentNode;
    const ulHijo = liItem.querySelector('ul.tmdropdown-menu');
    const tmID = findParentUl(liItem).id;
    const totalmenu = document.getElementById(tmID);

    const tmParams = _tm['tm_'+tmID];
    const tmFade = (tmParams.currentMedia == 'mobile') ? tmParams.mobile_fade : tmParams.desk_fade;

    if (isDoubleClicked(button, tmFade)) return;

    if(liItem.classList.contains('tm_closed')){

        liItem.classList.add('tm_open');
        liItem.classList.remove('tm_closed_done');
        slideDownPromise(ulHijo, tmFade).then(function () {
            liItem.classList.remove('tm_closed');
        });

        
    }else{
       

        liItem.classList.add('tm_closed');

        liItem.classList.remove('tm_open');
        slideUpPromise(ulHijo, tmFade).then(function () {
            liItem.classList.add('tm_closed_done');
        });
 
    }

    return;
}


///////////////////////////
/////onClick******HORIZONTAL/////////
///////////////////////////
function tmOpenHorizontal(button) {

    const divGroup = button.parentNode;
    const liItem = divGroup.parentNode;
    const ulItem = liItem.parentNode;
    const tmID = findParentUl(liItem).id;
    const totalmenu = document.getElementById(tmID);

    const tmParams = _tm['tm_'+tmID];
    const tmFade = (tmParams.currentMedia == 'mobile') ? tmParams.mobile_fade : tmParams.desk_fade;

    if (isDoubleClicked(button, tmFade)) return;

    //remove DONE from li parent
    liItem.classList.remove("tm_open_done");
    liItem.classList.remove("tm_closed_done");


    //OPEN
    if (liItem.classList.contains('tm_closed')) {

        //cierro TODOS
        const openLiElements = ulItem.querySelectorAll('ul li.tm_open');
        for (const openLiElement of openLiElements) {
            openLiElement.classList.add('tm_closed');
            openLiElement.classList.remove('tm_open');
        }

        isOnScreenV3(liItem);

        //abro este
        liItem.classList.add('tm_open');
        liItem.classList.remove('tm_closed');

        //DONE
        setTimeout(function () {
            liItem.classList.add('tm_open_done');
        }, tmFade);

    } else {
        //CLOSE

        liItem.classList.add('tm_closed');
        liItem.classList.remove('tm_open');

        //cierra los hijos
        const openLiElements = liItem.querySelectorAll('.tmdropdown');
        for (const openLiElement of openLiElements) {
            openLiElement.classList.add('tm_closed');
            openLiElement.classList.remove('tm_open');
        }

        setTimeout(function () {
            liItem.classList.add('tm_closed_done');
        }, tmFade);

    }

}


///////////////////////////
/////Find UL Parent/////////
///////////////////////////
function findParentUl(element) {
    // Obtiene el padre del elemento actual.
    const parent = element.parentNode;

    // Verifica si el padre es un elemento `ul` con clase `totalmenu`.
    if (parent.tagName === "DIV" && parent.classList.contains("totalmenu_wrapper")) {

        // Devuelve el padre.
        return parent;
    } else {
        // Si el padre no es un elemento `ul` con clase `totalmenu`, busca el padre del padre.
        return findParentUl(parent);
    }
}


///////////////////////////
/////cierraMenus not in use/////////
///////////////////////////
function cierraMenus(ul) {
    const liElements = ul.querySelectorAll("li.tm_open");

    for (const liElement of liElements) {
        liElement.classList.remove("tm_open");
        liElement.classList.add("tm_close");
    }
}


///////////////////////////
/////RESIZE/////////
///////////////////////////
const throttle = (func, wait) => {
    let previousTime = null;
    return (...args) => {
      if (previousTime === null || Date.now() - previousTime > wait) {
        previousTime = Date.now();
        func(...args);
      }
    };
  };
  
const windowResizeHandler = throttle(function() {
    const totalMenus = document.querySelectorAll('.totalmenu_wrapper');
    
    //hago portal de todos
    for (const tm of totalMenus) {
        const tmParams = _tm['tm_'+tm.id];
        tmPortal(tm, tmParams);
    }
}, 300);
  
window.addEventListener('resize', windowResizeHandler);


///////////////////////////
/////PORTAL/////////
///////////////////////////
function tmPortal(tm, tmParams){

    const windowWidth = window.innerWidth;

    if (windowWidth < tmParams.mediaw && (tmParams.portal == false || tmParams.currentMedia == 'desktop')) {          
        //portal to mobile
        const portalWrapper = document.querySelector(tmParams.tmPortalDestiny);
        portalWrapper.appendChild(tm);
        
        _tm['tm_'+tm.id].currentMedia = 'mobile';
        _tm['tm_'+tm.id].portal = true;
    } 

    if (windowWidth >= tmParams.mediaw && tmParams.currentMedia == 'mobile') {
        //portal to Desktop
        document.getElementById('tm_original_'+tm.id).appendChild(tm);
        _tm['tm_'+tm.id].currentMedia = 'desktop';
    } 

}


///////////////////////////
/////outerCLICKED/////////
///////////////////////////
function outerClick_v5() {

    document.addEventListener('click', function (event) {
        const isTotalmenu = document.querySelector('.totalmenu_wrapper') === event.target || event.target.closest('.totalmenu_wrapper');

        if (!isTotalmenu) {
            const totalmenuWrappers = document.querySelectorAll('.tm_behavior_desktop_horizontal');

            for (const totalmenuWrapper of totalmenuWrappers) {
                //close li tm_open
                const liElements = totalmenuWrapper.querySelectorAll('li.tm_open');
                for (const liElement of liElements) {
                    liElement.classList.remove('tm_open', 'tm_open_done');
                    liElement.classList.add('tm_closed');
                }
                //close ul dropdown
                const dropdownElements = totalmenuWrapper.querySelectorAll('.tmdropdown');
                for (const dElement of dropdownElements) {
                    dElement.classList.remove('tm_open');
                    dElement.classList.add('tm_closed');
                }
            }
        }

    });

}


///////////////////////////
/////IS DOUBLE CLICKED/////////
///////////////////////////
function isDoubleClicked(elementm, fade) {

    if('localStorage' in window){
        //with LOCALSTORAGE
        // Si ya se ha hecho clic, devuelve TRUE para indicar que este clic no está permitido.
        const lastClickTime = window.localStorage.getItem('lastClickTime');
        if (lastClickTime && Date.now() - lastClickTime < fade) {
            return true;
        }

        // Marca como hecho clic durante 1 segundo.
        window.localStorage.setItem('lastClickTime', Date.now());
        setTimeout(() => {
            window.localStorage.removeItem('lastClickTime');
        }, fade);

        // Devuelve FALSE para indicar que este clic se permitió.
        return false;

    }else{
    //with DOM
        // Si ya se ha hecho clic, devuelve TRUE para indicar que este clic no está permitido.
        const lastClickTime = element.getAttribute('data-last-click-time');
        if (lastClickTime && Date.now() - lastClickTime < fade) {
        return true;
        }

        // Marca como hecho clic durante 1 segundo.
        element.setAttribute('data-last-click-time', Date.now());
        setTimeout(() => {
        element.removeAttribute('data-last-click-time');
        }, fade);

        // Devuelve FALSE para indicar que este clic se permitió.
        return false;
    }

}


///////////////////////////
/////IS ON SCREEN/////////
///////////////////////////
function isOnScreenV3(objeto) {
    const hijo = objeto.querySelector('ul.tmdropdown-menu');

    // position obj
    const objX = objeto.offsetLeft;
    const objY = objeto.offsetTop;

    // width obj
    const objW = objeto.outerWidth;
    const objH = objeto.outerHeight;

    // width hijo
    const hijoW = hijo.outerWidth;
    const hijoH = hijo.outerHeight;

    // variable window w = window.innerWidth
    const windowW = window.innerWidth;
    // variable window h = window.innerHeight
    const windowH = window.innerHeight;

    // sum todo
    const sumaObjX = objX + objW + hijoW;
    const sumaObjY = objY + objH + hijoH;

    if (sumaObjX < 0) {
        hijo.classList.add('preventOffscreenX');
        console.log('OUT left');
    } else if (sumaObjX > windowW) {
        hijo.classList.add('preventOffscreenX');
        console.log('OUT right');
    }

    if (sumaObjY < 0) {
        console.log('OUT top');
    } else if (sumaObjY > windowH) {
        hijo.classList.add('preventOffscreenB');
        console.log('OUT bottom');
    }
}


///////////////////////////
/////START OPENERS/////////
///////////////////////////
function StartOpened(tmParams){
    
    if(
        tmParams.currentMedia == "desktop" && 
        tmParams.deskStartOpen == "true"  && 
        tmParams.desk_dir == "vertical"
    ){
        const desktopStartOpened = document.querySelectorAll('.desktop_li_start_open');

        desktopStartOpened.forEach((element) => {
            // Children
            if (element.querySelector('.tmdropdown-menu')) {
              // Remove the closed classes
              element.classList.remove('tm_closed');
              element.classList.remove('tm_closed_done');
              // Add the open class
              element.classList.add('tm_open');
              return;
            }
          
            // Bubble up
            const parents = element.querySelectorAll('.tmdropdown');
          
            parents.forEach((parent) => {
              // Check if the parent is closed
              if (parent.classList.contains('tm_closed')) {
                // Remove the closed classes
                parent.classList.remove('tm_closed');
                parent.classList.remove('tm_closed_done');
                // Add the open class
                parent.classList.add('tm_open');
              }
            });
        });
    }

    if(tmParams.currentMedia == "mobile" && tmParams.mobileStartOpen == "true"){
        
        const desktopStartOpened = document.querySelectorAll('.mobile_li_start_open');

        desktopStartOpened.forEach((element) => {
            // Children
            if (element.querySelector('.tmdropdown-menu')) {
              // Remove the closed classes
              element.classList.remove('tm_closed');
              element.classList.remove('tm_closed_done');
              // Add the open class
              element.classList.add('tm_open');
              return;
            }
          
            // Bubble up
            const parents = element.querySelectorAll('.tmdropdown');
          
            parents.forEach((parent) => {
              // Check if the parent is closed
              if (parent.classList.contains('tm_closed')) {
                // Remove the closed classes
                parent.classList.remove('tm_closed');
                parent.classList.remove('tm_closed_done');
                // Add the open class
                parent.classList.add('tm_open');
              }
            });
          });
    }

}

///////////////////////////
/////tmCustomColor/////////
///////////////////////////
function tmCustomColor(tm, tmParams){

    const elements = document.querySelectorAll(`#${tm.id}.tm_customcolor_1 .tmcustom`);
    
    elements.forEach((element) => {

        const classes = element.classList;
        if(!classes.contains('tmcustom')) return;

        for (const className of classes) {

            if(className.trim().startsWith('tmbg')){
                const backgroundColor = className?.split('tmbg')[1];
                element.querySelector('div.dxgroup').style.backgroundColor = `#${backgroundColor}`;
            }

            if(className.trim().startsWith('tma')){
                const anchorColor = className?.split('tma')[1];
                element.querySelector('a.dxlink').style.color = `#${anchorColor}`;
            }
        }
    });
}

///////////////////////////
/////SLIDERS/////////
///////////////////////////
const slideUpPromise = (target, duration = 500) => {
    return new Promise((resolve, reject) => {
        target.style.transitionProperty = 'height, margin, padding';
        target.style.transitionDuration = duration + 'ms';
        target.style.boxSizing = 'border-box';
        target.style.height = target.offsetHeight + 'px';
        target.offsetHeight;
        target.style.overflow = 'hidden';
        target.style.height = 0;
        target.style.paddingTop = 0;
        target.style.paddingBottom = 0;
        target.style.marginTop = 0;
        target.style.marginBottom = 0;
        window.setTimeout( () => {
                target.style.display = 'none';
                target.style.removeProperty('height');
                target.style.removeProperty('padding-top');
                target.style.removeProperty('padding-bottom');
                target.style.removeProperty('margin-top');
                target.style.removeProperty('margin-bottom');
                target.style.removeProperty('overflow');
                target.style.removeProperty('transition-duration');
                target.style.removeProperty('transition-property');
                resolve();
                //alert("!");
        }, duration);
    });
};

const slideDownPromise = (target, duration = 500) => {
    return new Promise((resolve, reject) => {
        target.style.removeProperty('display');
        let display = window.getComputedStyle(target).display;
        if (display === 'none') display = 'block';
        target.style.display = display;
        let height = target.offsetHeight;
        target.style.overflow = 'hidden';
        target.style.height = 0;
        target.style.paddingTop = 0;
        target.style.paddingBottom = 0;
        target.style.marginTop = 0;
        target.style.marginBottom = 0;
        target.offsetHeight;
        target.style.boxSizing = 'border-box';
        target.style.transitionProperty = "height, margin, padding";
        target.style.transitionDuration = duration + 'ms';
        target.style.height = height + 'px';
        target.style.removeProperty('padding-top');
        target.style.removeProperty('padding-bottom');
        target.style.removeProperty('margin-top');
        target.style.removeProperty('margin-bottom');
        window.setTimeout( () => {
            target.style.removeProperty('height');
            target.style.removeProperty('overflow');
            target.style.removeProperty('transition-duration');
            target.style.removeProperty('transition-property');
            resolve();
        }, duration);


    });
};

const slideTogglePromise = (target, duration = 500) => {
    return new Promise((resolve, reject) => {
        if (window.getComputedStyle(target).display === 'none') {
            slideDownPromise(target, duration).then(() => {
                resolve();
            });
        } else {
            slideUpPromise(target, duration).then(() => {
                resolve();
            });
        }



    });
};


