<?php
/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
 */

defined('_JEXEC') or die;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;

require_once __DIR__ . '/script.install.helper.php';

class Mod_TotalmenuInstallerScript extends Mod_TotalmenuInstallerScriptHelper
{
    public $name = 'JT | totalmenu';
    public $alias = 'mod_totalmenu';
    public $extension_type = 'module';
    public $plugin_folder = 'mod_totalmenu';
    public $minJtfwVersion = '4.0.3';

    public function onBeforeInstall()
    {

        if (!$this->jtfwInstalled()) {
            $app = Factory::getApplication();
            $app->enqueueMessage(Text::_('JT framework required. Please, <a target="_blank" href="https://users.jtotal.org/SOFT/framework/JTframework/jtframework_v4_current.zip">download at jtotal.org</a> and install it before.'), 'error');
            return false;
        }else{
        //check old framework update
            $this->checkOldFrameworkUpdate('https://users.jtotal.org/SOFT/UPDATES/MODULES/totalmenu-update.xml');
        }
    }
}
