<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Module\Totalmenu\Site\Fields;

defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;

$jtfwAutoload = JPATH_PLUGINS . '/system/jtframework/autoload.php';
if (is_file($jtfwAutoload)) {
    require_once $jtfwAutoload;
} else {
    Factory::getApplication()->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}

class TmClearCacheField extends FormField
{
    protected $type = 'TmClearCache';

    protected function getLabel()
    {
        //return "asdf";
    }

    protected function getInput()
    {

        $fV = '';
        $cache_path_abs = JPATH_SITE . '/cache/mod_totalmenu';

        $disabled = 'disabled';
        $countFiles = '0';
        if (Folder::exists($cache_path_abs)) {
            $disabled = '';
            $countFiles = count(Folder::files($cache_path_abs));
        }
        $fV .= '<a class="btn btn-primary btn-light  position-relative ' . $disabled . '" id="tm_clearCache">' . Text::_('MOD_TOTALMENU_CLEAR_CACHE') . '
        <span class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger">
        ' . $countFiles . '
        <span class="visually-hidden">css cached files</span>
      </span></a>';

        //List files
        //Folder::files($cache_path_abs);

        return $fV;
    }
}
