<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Module\Totalmenu\Site\Fields;

defined('JPATH_PLATFORM') or die;

//include_once(JPATH_SITE."/libraries/joomla/form/fields/color.php");

//jimport('joomla.form.formfield');

use Joomla\CMS\Form\Form;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use SimpleXMLElement;

class TmCustomv2Field extends FormField
{
    /**
     * The form field type.
     *
     * @var    string
     * @since  11.1
     */
    protected $type = 'TmCustomv2';
    protected $context;

    protected function getLabel()
    {
        return false;
    }

    protected function getInput()
    {

        $html = '';
        $json_values = '';

        $border_array = [
            'top',
            'right',
            'bottom',
            'left',
        ];

        $form_file = '
            <form addfieldprefix="Jtotal\Module\Totalmenu\Site\Fields">

                <field name="active_accordion" class="active_accordion" type="hidden"  default="1" />

                <!-- SIZE -->
                <fieldset name="tm_size_wrapper">

                    ' . $this->getInputLabel("tm_size_on") . '

                    <field name="tm_size" type="TmRange" append="px" size="3" default="14"  hiddenLabel="true"/>
                    <field name="a_tm_size" type="TmRange" append="px" size="3" default="14"  hiddenLabel="true"/>
                    <field name="c_tm_size" type="tmrange" append="px" size="3" default="14"  hiddenLabel="true"/>
                </fieldset>

                <!-- BACKGROUND -->
                <fieldset name="tm_background_wrapper">

                    ' . $this->getInputLabel("tm_background_on") . '

                    <field name="tm_background" type="JtColor" append="false" fa="fas fa-info" format="rgba" default="#000000"  hiddenLabel="true"/>
                    <field name="a_tm_background" type="JtColor" append="true" append_onclick="copy_color(this);" fa="fas fa-clone" format="rgba" default="#000000"  hiddenLabel="true"/>
                    <field name="c_tm_background" type="JtColor" append="true" append_onclick="copy_color(this);" fa="fas fa-clone" format="rgba" default="#000000"  hiddenLabel="true"/>
                </fieldset>

                <!-- COLOR -->
                <fieldset name="tm_color_wrapper">
                    ' . $this->getInputLabel("tm_color_on") . '
                    <field name="tm_color" type="JtColor" append="false" fa="fas fa-clone" format="rgba" default="#000000"  hiddenLabel="true"/>
                    <field name="a_tm_color" type="JtColor" append="true" append_onclick="copy_color(this);" fa="fas fa-clone" format="rgba" default="#000000"  hiddenLabel="true"/>
                    <field name="c_tm_color" type="JtColor" append="true" append_onclick="copy_color(this);" fa="fas fa-clone" format="rgba" default="#000000"  hiddenLabel="true"/>
                </fieldset>

                <!-- PADDING -->
                <fieldset name="tm_padding_wrapper">
                ' . $this->getInputLabel("tm_padding_on") . '
                <field name="tm_padding" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="true"  hiddenLabel="true"/>
                <field name="a_tm_padding" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="true"  hiddenLabel="true"/>
                <field name="c_tm_padding" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="true"  hiddenLabel="true"/>
                </fieldset>


                <!-- RADIUS WRAOOER -->
                <fieldset name="tm_border_radius_wrapper">
                ' . $this->getInputLabel("tm_border_radius_on") . '
                <field name="tm_border_radius" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="true" hiddenLabel="true"/>
                <field name="a_tm_border_radius" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="true" hiddenLabel="true"/>
                <field name="c_tm_border_radius" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="true" hiddenLabel="true"/>
                </fieldset>


                <fieldset name="tm_border_width_wrapper">
                ' . $this->getInputLabel("tm_border_width_on") . '
                <field name="tm_border_width" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="20" clone="true" hiddenLabel="true"/>
                <field name="a_tm_border_width" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="20" clone="true" hiddenLabel="true"/>
                <field name="c_tm_border_width" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="20" clone="true" hiddenLabel="true"/>
                </fieldset>

                <fieldset name="tm_border_color_wrapper">
                    ' . $this->getInputLabel("tm_border_color_on") . '
                    <field name="tm_border_color" type="JtColor" append="false" fa="fas fa-clone" format="rgba" default="#000000" hiddenLabel="true"/>
                    <field name="a_tm_border_color" type="JtColor" append="true" append_onclick="copy_color(this);" fa="fas fa-clone" format="rgba" default="#000000" hiddenLabel="true"/>
                    <field name="c_tm_border_color" type="JtColor" append="true" append_onclick="copy_color(this);" fa="fas fa-clone" format="rgba" default="#000000" hiddenLabel="true"/>
                </fieldset>

                <fieldset name="tm_code_wrapper">
                    ' . $this->getInputLabel("tm_code_on") . '
                    <field name="tm_code" type="textarea" label="" default="" filter="raw" mode="scss" buttons="no" syntax="scss" rows="10" cols="20" hiddenLabel="true"/>
                    <field name="a_tm_code" type="textarea" label="" default="" filter="raw" mode="scss" buttons="no" syntax="scss" rows="10" cols="20" hiddenLabel="true"/>
                    <field name="c_tm_code" type="textarea" label="" default="" filter="raw" mode="scss" buttons="no" syntax="scss" rows="10" cols="20" hiddenLabel="true"/>
                </fieldset>

                <fieldset name="tm_ul_wrapper">
                    ' . $this->getInputLabel("tm_ul_on") . '

                    <field name="tm_ul_border_radius" prepend="Border radius" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="false" hiddenLabel="true"/>
                    <field name="tm_ul_border_width" prepend="Border width" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="20" clone="true" hiddenLabel="true"/>
                    <field name="tm_ul_border_color" prepend="Border color" type="JtColor" append="false" fa="fas fa-clone" format="rgba" default="#000000" hiddenLabel="true"/>
                    <field name="tm_ul_box_shadow" prepend="Shadow" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="x,y,blur,spread" size="2" default="" max="50" clone="false" hiddenLabel="true"/>
                    <field name="tm_ul_box_shadow_color" prepend="Shadow color" type="JtColor" append="false" fa="fas fa-info" format="rgba" default="rgba(0,0,0,0)" hiddenLabel="true"/>
                </fieldset>

            ';

        $form_file .= '' . $this->getInputLabel("tm_border_on");

        $form_file .= '</form>
                ';

        $form_source = new SimpleXMLElement($form_file);

        $control = $this->name;
        $formname = 'totalmenu.' . str_replace(['jform[', '[', ']'], ['', '.', ''], $control);

        $targetName = explode('.', $formname);
        $targetDevice = $targetName[2];

        $control = $this->name;

        $formname = 'totalmenu.' . str_replace(['jform[', '[', ']'], ['', '.', ''], $control);
        $form = Form::getInstance($formname, $form_source->asXML(), ['control' => $control]);
        $form->bind($this->value);
        $formdata = $form->getData();

        $json_values .= json_encode($form->getData());

        $level = (int) filter_var($this->form->getName(), FILTER_SANITIZE_NUMBER_INT);

        $name = $this->form->getName();
        $md5name = str_replace('.', '', $name);

        $currentDevice = 'tm_mobile_custom';
        $targetDevice = 'tm_desktop_custom';
        $targetDeviceIcon = '<i class="fas fa-solid fa-arrow-left"></i><i class="fas fa-solid fa-desktop"></i>';

        $targetName = explode('.', $formname);
        if ($targetName[2] == 'tm_desktop_custom') {
            $currentDevice = 'tm_desktop_custom';
            $targetDevice = 'tm_mobile_custom';
            $targetDeviceIcon = '<i class="fas fa-solid fa-arrow-right"></i><i class="fas fa-solid fa-mobile-alt"></i>';
        }

////////////
//ON/OFF
////////////
        $toolbuttons = '
<div class="btn-group-toggle btn-group-xs" data-toggle="buttons" role="group">
    <a class="btn tm_magic btn-link" property="active_a_size"><i class="fa fa-clone"></i></a>
</div>
';

        $toolbuttons_multi = '
<div class="btn-group-toggle btn-group-xs" data-toggle="buttons" role="group">
    <a class="btn tm_magic_multi btn-link" property="active_a_size"><i class="fa fa-clone"></i></a>
</div>
';

//    <a class="btn tm_magic_bind active" role="button" aria-pressed="true"><i class="fa fa-link"></i></a>

//original

/* $active_accordion = '';
if(isset($this->value['active_accordion'])){
$active_accordion = $this->value['active_accordion'] == "1" ? 'tm_level_'.$level : '';
}

$html ='';

$html .= JHtml::_('bootstrap.startAccordion', $name, array('active' => $active_accordion));
$html .= JHtml::_('bootstrap.addSlide', $name, JText::_('MOD_TOTALMENU_LEVEL').$level,'tm_level_'.$level);
 */

        $active_accordion = '';
        if (isset($this->value['active_accordion'])) {
            $active_accordion = $this->value['active_accordion'] == "1" ? $md5name : '';
        }

        $html .= HTMLHelper::_('bootstrap.startAccordion', $name, array('active' => $active_accordion));
        $html .= HTMLHelper::_('bootstrap.addSlide', $name, Text::_('MOD_TOTALMENU_LEVEL') . $level, $md5name);

        $html .= '<table class="tmcustomv2 tm_table table">';

        $html .= '<thead>
    <th class="th_label">';

        $clone_above = '
    <a
    id="button_copy_up_' . $name . '"
    class="button_copy_up btn btn-outline-info"
    onclick="copyFromUp(\'' . $currentDevice . '\',\'' . $currentDevice . '\',\'' . ($level - 1) . '\', this)"><i class="fas fa-clone"></i><small><i class="fas fa-solid fa-arrow-up"></i></small></a>';

        $clone_device = '
    <a
    id="button_copy_up_' . $name . '"
    class="button_copy_up btn btn-outline-info"
    onclick="copyFromUp(\'' . $targetDevice . '\',\'' . $currentDevice . '\',\'' . $level . '\', this)"><i class="fas fa-clone"></i><small>' . $targetDeviceIcon . '</small></a>';

        if ($level != 0) {
            $html .= $clone_above;
        }

        $html .= $clone_device;

        $html .= '</th>';
        $html .= '<th>NORMAL</th>
    <th>ACTIVE</th>
    <th>CURRENT</th>
</thead>';

////////////
//BACKGROUND
////////////
        $elemento = 'background';

        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="' . $tr_class . '">
            <td class="tm_label">' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
            ' . $form->renderField('a_tm_' . $elemento) . '
            </td>

            <td>
            ' . $form->renderField('c_tm_' . $elemento) . '
            </td>

</tr>';

////////////
//COLOR
////////////
        $elemento = 'color';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
            ' . $form->renderField('a_tm_' . $elemento) . '
            </td>

            <td>
            ' . $form->renderField('c_tm_' . $elemento) . '
            </td>

</tr>';

////////////
//SIZE
////////////

        $elemento = 'size';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="' . $tr_class . '">
            <td class="tm_label">' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('a_tm_' . $elemento) . '
                    ' . $toolbuttons . '
                </div>
            </td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('c_tm_' . $elemento) . '
                    ' . $toolbuttons . '
                </div>
            </td>

</tr>';

////////////
//PADDING
////////////
        $elemento = 'padding';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
            <div class="d-flex">
                ' . $form->renderField('a_tm_' . $elemento) . '
                ' . $toolbuttons_multi . '
            </div>
        </td>

        <td>
            <div class="d-flex">
                ' . $form->renderField('c_tm_' . $elemento) . '
                ' . $toolbuttons_multi . '
            </div>
        </td>

</tr>';

////////////
//BORDER COLOR
////////////
        $elemento = 'border_color';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="tm_start_group ' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
            ' . $form->renderField('a_tm_' . $elemento) . '
            </td>

            <td>
            ' . $form->renderField('c_tm_' . $elemento) . '
            </td>

</tr>';

////////////
//BORDER WIDTH
////////////
        $elemento = 'border_width';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr  class="tm_end_group ' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('a_tm_' . $elemento) . '
                    ' . $toolbuttons_multi . '
                </div>
            </td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('c_tm_' . $elemento) . '
                    ' . $toolbuttons_multi . '
                </div>
            </td>

</tr>';

////////////
//BORDER RADIUS
////////////
        $elemento = 'border_radius';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="tm_group ' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('a_tm_' . $elemento) . '
                    ' . $toolbuttons_multi . '
                </div>
            </td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('c_tm_' . $elemento) . '
                    ' . $toolbuttons_multi . '
                </div>
            </td>

</tr>';

////////////
//EDITOR
////////////
        $elemento = 'code';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="tm_tr_code ' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>
            <td class="tm_normal">' . $form->renderField('tm_' . $elemento) . '</td>

            <td>
            ' . $form->renderField('a_tm_' . $elemento) . '
            </td>

            <td>
                <div class="d-flex">
                    ' . $form->renderField('c_tm_' . $elemento) . '
                </div>
            </td>

</tr>';

/*

////////////
//POSITIONS
////////////
//$elemento = 'border_top';
$html2 = '<tr>
<td class="tm_label">
'.$form->renderField('tm_border_on').'</td>
<td>';

//REGULAR
////////////
//$html .= JHtml::_('bootstrap.startAccordion', 'tmacordeon_top', array('active' => 'tmacordeon_1'));

foreach ($border_array as $key => $value) {

//$html .= JHtml::_('bootstrap.addSlide', 'tmacordeon_top', "asdf",'tm_'.$level.'_border_'.$value);

$html2 .='<div class="tm_border" id="tm_level_'.$level.'_'.$value.'">
<small>tm_level_'.$level.'_'.$value.'</small>
'.$form->renderField('tm_border_'.$value.'_color').'
'.$form->renderField('tm_border_'.$value.'_width').'
'.$form->renderField('tm_border_'.$value.'_padding').'
'.$form->renderField('tm_border_'.$value.'_radius').'
</div>';

//$html .= JHtml::_('bootstrap.endSlide');

}

$html2 .='<div class="btn-group" role="group" aria-label="">';

$html2 .='<button type="button" class="btn btn-default btn_popover btn_popover_'.$value.'" id="tm_button_level_'.$level.'_'.$value.'">';

if($key==0){
$html2 .='<i class="fas fa-long-arrow-alt-up"></i>';
}elseif($key==1){
$html2 .='<i class="fas fa-long-arrow-alt-right"></i>';
}elseif($key==2){
$html2 .='<i class="fas fa-long-arrow-alt-down"></i>';
}else{
$html2 .='<i class="fas fa-long-arrow-alt-left"></i>';
}

$html2 .='</button>';

$html2 .='</div>';

//$html .= JHtml::_('bootstrap.endAccordion');

$html2 .='</td>';

$html2 .='<td>';
//ACTIVE
////////////
//$html .= JHtml::_('bootstrap.startAccordion', 'tmacordeon_top', array('active' => 'tmacordeon_1'));
$html2 .='<div class="btn-group" role="group" aria-label="">';

foreach ($border_array as $key => $value) {

$html2 .='<button type="button" class="btn btn-default btn_popover btn_popover_'.$value.'" id="tm_button_level_'.$level.'_'.$value.'">';

if($key==0){
$html2 .='<i class="fas fa-long-arrow-alt-up"></i>';
}elseif($key==1){
$html2 .='<i class="fas fa-long-arrow-alt-right"></i>';
}elseif($key==2){
$html2 .='<i class="fas fa-long-arrow-alt-down"></i>';
}else{
$html2 .='<i class="fas fa-long-arrow-alt-left"></i>';
}

$html2 .='</button>';

//$html .= JHtml::_('bootstrap.addSlide', 'tmacordeon_top', "asdf",'tm_'.$level.'_border_'.$value);

$html2 .='<div class="webui-popover-content" id="tm_level_'.$level.'_'.$value.'">
<small>tm_level_'.$level.'_'.$value.'</small>
'.$form->renderField('tm_a_border_'.$value.'_color').'
'.$form->renderField('tm_a_border_'.$value.'_width').'
'.$form->renderField('tm_a_border_'.$value.'_padding').'
'.$form->renderField('tm_a_border_'.$value.'_radius').'
</div>';

//$html .= JHtml::_('bootstrap.endSlide');

}

//$html .= JHtml::_('bootstrap.endAccordion');

$html2 .='</div>';
$html2 .='</td>

<td>
'.$form->renderField('c_tm_'.$elemento).'
</td>

</tr>'; */

////////////
//WRAPPER
////////////
        $elemento = 'ul';
        $tr_class = (!$formdata->get('tm_' . $elemento . '_on', '0') ? 'tm_tr_on_0' : '');
        $html .= '<tr class="tm_tr_code ' . $tr_class . '">
            <td class="tm_label">

            ' . $form->renderField('tm_' . $elemento . '_on', '0') . '</td>

            <td class="tm_normal" colspan="1">
                ' . $form->renderField('tm_ul_box_shadow') . '
                    <hr class="tm_hr_wrapper">
                ' . $form->renderField('tm_ul_box_shadow_color') . '
            </td>

            <td class="tm_normal" colspan="2">
                ' . $form->renderField('tm_ul_border_radius') . '
                <hr class="tm_hr_wrapper">
                ' . $form->renderField('tm_ul_border_width') . '
                <hr class="tm_hr_wrapper">
                ' . $form->renderField('tm_ul_border_color') . '

            </td>


</tr>';

        $html .= '</table>';

/*
<fieldset name="tm_ul_wrapper">
'.$this->getInputLabel("tm_ul_on").'
<field name="tm_ul_border_radius" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="50" clone="false"/>
<field name="tm_ul_border_width" type="TmGroupedInput" input_type="number" append="px"  quantity="4" title="top,right,bottom,left" size="2" default="" max="20" clone="true"/>
<field name="tm_ul_border_color" type="JtColor" append="false" fa="fas fa-clone" format="rgba" default="#000000"/>
</fieldset>
 */

        $html .= $form->renderField('active_accordion');

        $html .= '    <script>
jQuery(function () {
    //jQuery("#tm_button_level_0_top").popover(html: true);

    //jQuery(\'#tm_button_level_0_top\').webuiPopover({url:jQuery(this).data(\'popover-content\'), animation:\'pop\'});

    /* jQuery(\'#tm_button_level_0_top\').popover({
        container: \'body\',
        placement: "bottom",
        html: true,
        viewport: { selector: \'.container\', padding: 5 },
        content: function () {
            var clone = jQuery(jQuery(this).data(\'popover-content\')).clone(true).removeClass(\'hide\');
            return clone;
        }
      });
 */

});
</script>';

        $html .= HTMLHelper::_('bootstrap.endSlide');
        $html .= HTMLHelper::_('bootstrap.endAccordion');

        return $html;

        // Unswitch the layouts that Joomla has applied!
        // $this->layout = $this->control === 'simple' ? $this->layout . '.simple' : $this->layout . '.advanced';
        //$this->layout = str_replace(array(".simple", ".advanced"), "", $this->layout);
        HTMLHelper::_('behavior.colorpicker');

        //return "lala";
    }

    protected function getPopover()
    {
    }

    //SHOW / HIDE TR
    protected function getInputLabel($name)
    {

        return '<field name="' . $name . '"
                type="radio"
                default="0"
                class="mini-btn btn-group btn-group-xs"
                onchange="changeInputOnOff(this.id)"
                label="MOD_TOTALMENU_' . strtoupper($name) . '"
                layout="joomla.form.field.radio.switcher"
                >
                <option value="0">TM_JNO</option>
                <option value="1">TM_JYES</option>
        </field>';
    }
}
