<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Module\Totalmenu\Site\Fields;

defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\Registry\Registry;

$jtfwAutoload = JPATH_PLUGINS . '/system/jtframework/autoload.php';
if (is_file($jtfwAutoload)) {
    require_once $jtfwAutoload;
} else {
    Factory::getApplication()->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}

class TmShowCssPathField extends FormField
{
    protected $type = 'TmShowCssPath';

    protected function getLabel()
    {
        return parent::getLabel();
    }

    protected function getInput()
    {

        $fV = '';
        $cache_path_abs = JPATH_SITE . '/cache/mod_totalmenu';
        $cache_path_relative = Uri::root() . 'cache/mod_totalmenu';


        $jinput = Factory::getApplication()->input;
        $id = $jinput->get('id', 0, 'INT');

        //var_dump($this->form->getValue('params')->get('dx_uniquename'));
        $params = new Registry($this->form->getValue('params'));
        $uniqueName = $params->get('dx_uniquename').$id;

        $path = $cache_path_relative . '/' . $uniqueName . '.css';

        $fV .= '<div class="input-group input-group-sm">
            <input id="copy-input-'.$id.'" type="text" class="form-control" aria-label="readonly input example" readonly value="'.$path.'">
            <button type="button" class="btn btn-primary" id="copy-button" onClick="navigator.clipboard.writeText(document.getElementById(\'copy-input-'.$id.'\').value)"><i class="fas fa-copy"></i></button>
        </div>';

        return $fV;
    }
}
