<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Module\Totalmenu\Site\Fields;

defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

if (is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php')) {
    require_once JPATH_PLUGINS . '/system/jtframework/autoload.php';
} else {
    $app = Factory::getApplication();
    $app->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}

class TmbackendField extends FormField
{
    protected $type = 'Tmbackend';

    protected function getLabel()
    {
        //return "<strong>License</strong>";
    }

    protected function getInput()
    {
        //$field_set = $this->form->getFieldset();

        /** @var CMSApplication $app */
        $app = Factory::getApplication();
        $document = $app->getDocument();

        $module_path = URI::root() . 'modules/mod_totalmenu';
        $media_path = URI::root() . 'media/mod_totalmenu';
        $cache_path = URI::root() . 'cache/mod_totalmenu';
        $base_path = URI::root();


        $wa = $app->getDocument()->getWebAssetManager();
        $wa->registerAndUseScript('tm_backend.js', $media_path . '/js/tm_backend_j4.js', [], ['defer' => true]);
        $wa->registerAndUseStyle('tm_backend.css', $media_path . '/assets/css/tmbackend_j4.css', [], []);

        $wa->addInlineScript("const tm_basepath = '{$base_path}'");

        $field_value = "";

        return $field_value;
    }
}
