<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Module\Totalmenu\Site\Fields;

defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Uri\Uri;
use SimpleXMLElement;

//jimport( 'joomla.form.form' );

if (is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php')) {
    require_once JPATH_PLUGINS . '/system/jtframework/autoload.php';
} else {
    $app = Factory::getApplication();
    $app->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}

class TmimportField extends FormField
{
    /**
     * The form field type.
     *
     * @var    string
     * @since  11.1
     */
    protected $type = 'Tmimport';

    protected function getLabel()
    {

        $this->label = isset($this->element['label']) ? (string) Text::_($this->element['label']) : '';

        //return $this->label;
        return $this->label;
    }

    protected function getInput()
    {

        $onchange = $this->onchange ? ' onchange="' . $this->onchange . '"' : '';

        $name = $this->name;
        $id = $this->id;
        $this->default = (string) $this->element['default'] ? (string) $this->element['default'] : '0';
        $this->value = ($this->value ?: $this->default);

        $export = '';

        /////////////////
        /////////////////
        /////////////////
        //GET ROUTE FROM FILE /////////
        /////////////////
        $export .= "<script>



		function tmImport(type='json'){

			var data =  new FormData();
			data.append( 'importzip', jQuery('#jform_importzip')[0].files[0]);

			var id = '" . $this->form->getData()->get('id') . "';


			data.append( 'token', '" . Session::getFormToken() . "');

			var getUrl = '" . Uri::root() . "index.php?option=com_ajax&module=totalmenu&method=importZip&format=json&id='+id+'&raw=true&filetype='+type;

			var jqxhr = jQuery.ajax({

				type: 'POST',
				url: getUrl,
				cache: false,
				dataType: 'json',
				data:data,
				processData: false,
				contentType: false,
				jsonp: false

			}).done(function(e) {
                console.log(e.data);

                if(e.data == true){
                    window.location.reload(true);
                 }

		    })
		  .fail(function(e) {

			console.log('ERROR');
			console.log(e.data);

		  });

		}
        </script>
        ";

        $app = Factory::getApplication('administrator');

        $importXml2 = new SimpleXMLElement('<field
            type="file"
            name="importzip"
            label=""
            default=""
            size="10"
            accept=".zip"
            onchange="tmImport();"
        />');
        $this->form->setField($importXml2);

        $export .= '<div class="tmimport_wrapper" style="display:inline-flex;">
            <a class="btn btn-success tmimport_button" onclick="document.getElementById(\'tmimport_zip_' . $this->id . '\').style=\'diplay:block;\'">' . Text::_('MOD_TOTALMENU_IMPORT') . '</a>
        ';

        $export .= '<div id="tmimport_zip_' . $this->id . '" class="tmimport_zip" style="display:none;">' . $this->form->renderField('importzip') . '</div>';

        $export .= '</div>';

        return $export;
    }
}
