<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

use Joomla\CMS\Uri\Uri;
use JTotal\Module\Totalmenu\Site\Helper\TotalmenuDebug;
use Jtotal\Module\Totalmenu\Site\Helper\TotalmenuHelper;
use Jtotal\Module\Totalmenu\Site\Helper\TotalmenuProcessCss;

defined('_JEXEC') or die;

$jmobile = false;
$tm_jmobile = 0;

//mobile
$tm_mobile_on = $params->get('tm_mobile_on', 1);
//desktop
$tm_desktop_on = $params->get('tm_desktop_on', 1);

//detection technique
$detection = $params->get('tm_mobile_detection', 'media');


//DEVICE
/*
if ($detection == 'device') {
    TotalmenuDebug::addDebug("Detection", 'Device', 'mobile');


    var_dump(JTmobiledetect::getMobileDetect());
    if (JTmobiledetect::getMobileDetect()) {
        $detect = new Mobile_Detect;

        if ($detect->isMobile()) {
            if ($detect->isTablet()) {
                if ($tablet == 0) {
                    $jmobile = false;
                } else {
                    $jmobile = true;
                }
            } else {
                $jmobile = true;
            }
        } else {
            $jmobile = false;
        }

        if ($jmobile) {
            //$tm_jmobile = 0;
            $tm_jmobile = 1;
        } else {
            //$tm_jmobile = 1;
            $tm_jmobile = 0;
        }

        $tm_js_params['tm_jmobile'] = $tm_jmobile;

        if ($jmobile && $tm_mobile_on != 1) {
            return;
        }
        if (!$jmobile && $tm_desktop_on == 0) {
            return;
        }
    }
} else {
*/
    TotalmenuDebug::addDebug("DETECTION", 'Media', 'ruler-horizontal');
    //MEDIA
    $tm_js_params['tm_jmobile'] = 'media';
    $tm_js_params['media_w'] =  $params->get('tm_mobile_media_w', '992');

//}


if ($tm_debug) {
    $msg = 'totalmenu "' . $unique . '" jmobile:' . var_export($jmobile, true);
}

TotalmenuDebug::addDebug("jmobile", var_export($jmobile, true), 'mobile');

///////////////////
//  DETEC MOBILE //
///////////////////
$tablet = $params->get('tm_mobile_as_tablet', 0);

TotalmenuDebug::addDebug("ID", $unique, 'id-card-alt');

$tm_js_params['debug'] = $tm_debug;
$tm_js_params['unique'] = $unique;
$tm_js_params['detection'] = $params->get('tm_mobile_detection', 'media');
$tm_js_params['ismobile'] = $tm_jmobile;

$tm_js_params['tm_mobile'] = array(
    'on' => ($params->get('tm_mobile_on', 1) == 1) ? true : false,
    'direction' => $params->get('tm_mobile_base', 'vertical'),
    'loadcss' => $params->get('tm_mobile_loadcss', 1),
    'fadein' => $params->get('tm_mobile_fadein', 300),
);

$tm_js_params['tm_desktop'] = array(
    'on' => ($params->get('tm_desktop_on', 1) == 1) ? true : false,
    'direction' => $params->get('tm_desktop_base', 'horizontal'),
    'click_hover' => $params->get('tm_desktop_click_hover', 'click'),
    'loadcss' => $params->get('tm_desktop_loadcss', 1),
    'fadein' => $params->get('tm_desktop_fadein', 300),
);


//MEDIA LOAD


    //check DESKTOP file exist
    $desktop_file = 'cache/mod_totalmenu/' . $unique . '_desktop_' . $tm_desktop_style . '.css' . $tm_force_reloadcss;
    $css_file_desktop_exists = file_exists($desktop_file);
    //check MOBILE file exist
    $mobile_file = 'cache/mod_totalmenu/' . $unique . '_mobile_' . $tm_mobile_style . '.css' . $tm_force_reloadcss;
    $css_file_mobile_exists = file_exists($mobile_file);


    if(!$css_file_desktop_exists || !$params->get('tm_production', 1)) TotalmenuProcessCss::getDesktopCSS($params, $unique);
    if(!$css_file_mobile_exists || !$params->get('tm_production', 1)) TotalmenuProcessCss::getMobileCSS($params, $unique);


    if ($tm_js_params['tm_desktop']['on'] && $params->get('tm_desktop_loadcss', 1) == 1) {

        TotalmenuDebug::addDebug("Load tm_desktop", 'cache/mod_totalmenu/' . $unique . '_desktop_' . $tm_desktop_style . '.css' . $tm_force_reloadcss, 'css3');

        echo '<noscript id="deferred-styles_tm_desktop_' . $unique . '">
            <link rel="stylesheet" type="text/css" href="cache/mod_totalmenu/' . $unique . '_desktop_' . $tm_desktop_style . '.css' . $tm_force_reloadcss . '"/>
        </noscript>';
    }

    if ($tm_js_params['tm_mobile']['on'] && $params->get('tm_mobile_loadcss', 1) == 1) {

        TotalmenuDebug::addDebug("Load tm_mobile", 'cache/mod_totalmenu/' . $unique . '_mobile_' . $tm_mobile_style . '.css' . $tm_force_reloadcss, 'css3');

        echo '<noscript id="deferred-styles_tm_mobile_' . $unique . '">
            <link rel="stylesheet" type="text/css" href="cache/mod_totalmenu/' . $unique . '_mobile_' . $tm_mobile_style . '.css' . $tm_force_reloadcss . '"/>
        </noscript>';
    }
    


?>