<?php

/**
 * @package     Joomla.Site
 * @subpackage  mod_menu
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\CMS\HTML\HTMLHelper;
use Jtotal\Module\Totalmenu\Site\Helper\TotalmenuHelper;

////////////////////Remplaza fa classes/////////////////////////

$fa_icon = $classes_fa ? '<i class="tm_fa_menu ' . $classes_fa . '"></i>' : '';

$attributes = array();

if ($item->anchor_title) {
    $attributes['title'] = $item->anchor_title;
}

if ($item->anchor_css) {
    $attributes['class'] = $item->anchor_css;
}

if ($item->anchor_rel) {
    $attributes['rel'] = $item->anchor_rel;
}

if ($item->id == $active_id) {
    $attributes['aria-current'] = 'location';

    if ($item->current) {
        $attributes['aria-current'] = 'page';
    }
}

if ($item->deeper) {
    //$class = 'class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"';
}

$has_image = '';

if ($item->menu_image) {

    // The link is an image, maybe with its own class
    $image_attributes = [];

    $imgClean = HTMLHelper::cleanImageURL($item->menu_image);

    //GET IMAGE SIZE from image or from file (slower)
    if (($imgClean->attributes['width'] == 0) && ($imgClean->attributes['height'] == 0)) {
        $imageSize = list($width, $height) = getimagesize($imgClean->url);
        $image_attributes['width'] = $imageSize[0];
        $image_attributes['height'] = $imageSize[1];
    } else {
        $image_attributes['width'] = $imgClean->attributes['width'];
        $image_attributes['height'] = $imgClean->attributes['height'];
    }

    if ($item->menu_image_css) {
        $image_attributes['class'] = $item->menu_image_css;
    }

    $linktype = HTMLHelper::_('image', $imgClean->url, $item->alias . '-image', $image_attributes);

    $itemParams->get('menu_text', 1) ?
    //$linktype = $linktype.'<span class="image-title">' . $item->title . '</span> ' : $linktype = $linktype;
    $linktype = $linktype . '' . $item->title . '' : $linktype = $linktype;

    $has_image = 'hasimage';
} else {
    $itemParams->get('menu_text', 1) ?
    //$linktype = '<span class="tm_title">'.$item->title.'</span>': $linktype = '' ;
    $linktype = '' . $item->title . '' : $linktype = '';
}

$class = $item->anchor_css ? 'class="' . $item->alias . ' ' . $has_image . ' tm_alias_' . $item->alias . ' dxlink" ' : 'class="tm_alias_' . $item->alias . ' dxlink"';
$title = $item->anchor_title ? 'title="' . $item->anchor_title . '" ' : '';

//LINK
if ($item->type == 'superparent' || $item->type == 'separator') {
    $item->flink = '#';
}
//ALIAS
if ($item->type == 'alias' && $tm_parent_element == 'alias') {
    $item->flink = '#';
}

$tabindex = '0';

if ($item->id == $active_id) {
    //$tabindex = '1';
}


switch ($item->browserNav) {
    default:
    case 0:

?>
<div class="<?php echo 'tm_alias_' . $item->alias . ' dxgroup'; ?>">

    <?php
        $onclick = '';
        if ($item->deeper && $tm_version = 5) {
            $onclick = 'tmOpenSubmenu(this)';
        }

        $href = ($item->flink == '#') ? 'javascript:void(0)' : $item->flink;
    ?>
        
    <a onclick="<?php echo $onclick; ?>" role="button" tabindex="<?php echo $tabindex; ?>" draggable="false" <?php echo $class; ?> href="<?php echo $href; ?>"
        <?php echo $title; ?>><?php echo $fa_icon . $linktype; ?></a>

    <?php
        if ($item->deeper) {
            echo TotalmenuHelper::getCaret($item, $params, $unique);
        }
    ?>
</div>

<?php

        break;
    case 1:
        // _blank

        ?>
<div class="<?php echo 'tm_alias_' . $item->alias . ' dxgroup'; ?>">
    <a tabindex="0" draggable="false" <?php echo $class; ?>href="<?php echo $item->flink; ?>" target="_blank"
        <?php echo $title; ?>><?php echo $linktype; ?></a>
</div>
<?php
break;
    case 2:
        // window.open

        ?><a tabindex="0" draggable="false" <?php echo $class; ?>href="<?php echo $item->flink; ?>"
    onclick="window.open(this.href,'targetWindow','toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes');return false;"
    <?php echo $title; ?>><?php echo $linktype; ?></a>
<?php
break;
}