<?php

/**
 * @package     Joomla.Site
 * @subpackage  based on mod_menu
 *
 * @copyright   Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\HTML\HTMLHelper;
use Jtotal\Module\Totalmenu\Site\Helper\TotalmenuHelper;

defined('_JEXEC') or die;


////////////////////Remplaza fa classes/////////////////////////

$getFa  = TotalmenuHelper::getFaFromIconClass($item);
$classes_fa = $getFa['fa'];
$fa_icon = $classes_fa ? '<i class="tm_fa_menu ' . $classes_fa . '"></i>' : '';

//remove menu_icon joomla default
$item->menu_icon = '';

////////////////////Remplaza fa classes/////////////////////////


$attributes = array();

if ($item->anchor_title) {
    $attributes['title'] = $item->anchor_title;
}


$attributes['class'] = 'dx_url_link dxlink ' . $item->anchor_css;



if ($item->anchor_rel) {
    $attributes['rel'] = $item->anchor_rel;
}

$linktype = $item->title;

$check_menuicon = false;

if (isset($item->menu_icon)) {
    if ($item->menu_icon) {
        $check_menuicon = true;
    }
}

//ICON
if ($check_menuicon) {
    // The link is an icon
    if ($itemParams->get('menu_text', 1)) {
        // If the link text is to be displayed, the icon is added with aria-hidden
        $linktype = '<span class="p-2 ' . $item->menu_icon . '" aria-hidden="true"></span>' . $item->title;
    } else {
        // If the icon itself is the link, it needs a visually hidden text
        $linktype = '<span class="p-2 ' . $item->menu_icon . '" aria-hidden="true"></span><span class="visually-hidden">' . $item->title . '</span>';
    }
//IMG
} elseif ($item->menu_image) {
    // The link is an image, maybe with an own class
    $image_attributes = [];

    if ($item->menu_image_css) {
        $image_attributes['class'] = $item->menu_image_css;
    }

    $linktype = HTMLHelper::_('image', $item->menu_image, $item->title, $image_attributes);

    if ($itemParams->get('menu_text', 1)) {
        $linktype .= '<span class="tm_title image-title">' . $item->title . '</span>';
    }
}

/*
else{

    $item->params->get('menu_text', 1) ?
    $linktype = '<span class="tm_title">'.$item->title.'</span>':
    $linktype = '' ;

}
*/

//TOTALMENU
$linktype = $fa_icon . $linktype;

if ($item->deeper) {
    $linktype .= TotalmenuHelper::getCaret($item, $params, $unique);
}


if ($item->browserNav == 1) {
    $attributes['target'] = '_blank';
    $attributes['rel'] = 'noopener noreferrer';

    if ($item->anchor_rel == 'nofollow') {
        $attributes['rel'] .= ' nofollow';
    }
} elseif ($item->browserNav == 2) {
    $options = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,' . $params->get('window_open');

    $attributes['onclick'] = "window.open(this.href, 'targetWindow', '" . $options . "'); return false;";
}



echo '<div class="dxgroup tm_url">';

echo '<a role="menuitem" draggable="false" 
    href="' . OutputFilter::ampReplace(htmlspecialchars($item->flink, ENT_COMPAT, 'UTF-8', false)) . '"';

foreach ($attributes as $key => $attribute) {
    echo $key . '="' . $attribute . '" ';
}

echo '>';

echo $linktype;

echo '<i class="fa-solid fa-arrow-up-right-from-square"></i>';

echo '</a>';




echo '</div>';
